/*
   MindtelSocket.h

   Simpler sockets for windows.
*/
#ifndef MINDTELSOCKET_H
#define MINDTELSOCKET_H

class MindtelSocket {
public:
	MindtelSocket();
	void Send( const char* buf, int buflen );
	int Recv( char* buf, int buflen );
	void Close();
protected:
	int sockfd;

private:
};

class MindtelSocketClient : public MindtelSocket {
public:
	MindtelSocketClient( char* ip, int portNumber );
	bool Connect();
	void GET( char* page );
	int simpleXmlRpc( char* page, char* method, char* params );
private:
	char ip[30];
	int portNumber;
};

class MindtelSocketServer : public MindtelSocket {
public:
	MindtelSocketServer( int portNumber );
	bool AcceptConnection();
	void SendPage( char* text );
	void Redirect( char* location );
	void GetPage( char* page );
	void Run();

private:
    int listenfd;
	struct sockaddr_in servaddr;
    struct sockaddr_in	cliaddr;
};

#endif