#include "stdafx.h"
#include "VisualObject.h"
#include "log.h"

VisualObject::VisualObject( INodeObject* transform ) {
	script_in1 = NULL;
	script_in2 = NULL;
	script_in3 = NULL;
	script_in4 = NULL;
	script_in5 = NULL;
	pTransformNode = transform;
	embeddedTransform = NULL;
	pScale = NULL;
	pRotation = NULL;
	pLocation = NULL;
	pGroup = NULL;
	pLabel = NULL;
	labelString = NULL;
	pMarker = NULL;
	next = NULL;
	base_set = false;
}

void VisualObject::scaleNextBaseLocation( float base ) { 
	if ( next != NULL ) 	
		next->scaleBaseLocation( base );	
}

void VisualObject::scaleBaseLocation( float base ) {
	//log_messagef("scaling base Location", base );
	if ( !base_set ) {
		float x,y,z;
		if ( SUCCEEDED ( pLocation->get_X( &x )) && SUCCEEDED( pLocation->get_Y( &y )) && SUCCEEDED( pLocation->get_Z( &z ))) {
			base_x = x;
			base_y = y;
			base_z = z;
			base_set = true;
			//log_messagef("base_x just set to", base_x );
			//log_messagef( "base_y just set to", base_y );
			//log_messagef( "base_z just set to", base_z );
		}
	}
	if ( base_set ) {
		float x = base_x * base;
		float y = base_y * base;
		float z = base_z * base;
		//log_messagef( "adjusting X to", x );
		//log_messagef( "adjusting Y to", y );
		//log_messagef( "adjusting Z to", z );
		pLocation->put_X( x );
		pLocation->put_Y( y );
		pLocation->put_Z( z );
	}
}

void VisualObject::SetScriptInputs( ISFInt32Object* in1, ISFInt32Object* in2, ISFInt32Object* in3, ISFInt32Object* in4, ISFInt32Object* in5 ) {
	script_in1 = in1;
	script_in2 = in2;
	script_in3 = in3;
	script_in4 = in4;
	script_in5 = in5;
/*	if ( script_in1 == NULL ) {
		log_message( "No script inputs found" );
	} else {
		log_message( "OK, in VisualObject it it NOT NULL" );
	}*/
}

void VisualObject::SetEmbeddedTransform( INodeObject* xform ) {
	embeddedTransform = xform;
}

void VisualObject::setLabel( char* label ) {
	if ( pLabel != NULL ) {
		CString xx( label );
		pLabel->put_Value( xx.AllocSysString() );
		if ( labelString != NULL ) {
			free( labelString );
		}
		labelString = newstrcpy( label );
	}
}

void VisualObject::setLabelString( char* ls ) { 
	if ( ls != NULL ) {
		if ( labelString != NULL ) 
			free( labelString ); 
		labelString = newstrcpy( ls ); 
	}
}

