#include <stdio.h>
#include <io.h>
#include <winsock2.h>
#include "MindtelSocket.h"
#include "FormValues.h"

static void usage() {
	printf( "Usage: mserver <port>\n" );
}

void log_error( char* s ) {
	printf( "%s\n", s );
}

void log_message( const char* s ) {
	printf( "%s\n", s );
}
void log_message1( const char* s, const char* s1 ) {
	printf( "%s %s\n", s, s1 );
}

/*
 *  POST accesses are external method calls, since what to do with
 *  the FORM data is application specific.
 */

bool doPost( char* pageToGet, char* buf, MindtelSocketServer* server ) {
	printf( "POST to page %s\n", pageToGet );
	FormValues fv( buf );
	fv.Dump();
	if ( fv.doneWithHeader() ) {
		printf( "OK, I'm done with header\n" );
		server->GetPage( "/world/worldlinks.html" );
	} else {
		printf( "Not done with header\n" );
	}
	return( fv.doneWithHeader() );
}

//
//  Create and run a server on a particular port.
//
int main( int argc, char* argv[] ) {
	if ( argc != 2 ) {
		usage();
		exit( 0 );
	} else {
		int port = atoi( argv[1] );
		if ( port == 0 ) {
			usage();
			exit( 0 );
		}
		printf( "Creating Server\n" );
		MindtelSocketServer server( port );
		printf( "Running Server\n" );
		server.Run();
		printf( "Run is complete\n" );
	}
	return( 0 );
}
